﻿if KarmaStub:isLib("LibKarmaAce", 1.1, "$Revision: 11 $") then return end


--[[
	Simple integrated automated lightweight support for other basic desparate libraries and systems	
]]

LibKarmaAce = LibKarmaAce or  {

}


function LibKarmaAce:LoadLocales( frame, inst, locale, L )

	L["Help"] = "Help"
	L["Show Help"] = "Show Help"
	L["Main Window"] = "Main Window"
	L["Show Main Window"] = "Show Main Window"
	L["Options"] = "Options"
	L["Show Options"] = "Show Options"
	L["Item Options"] = "Item Options"
	L["Show Item Options"] = "Show Item Options"
	L["ADDON_TOOLTIP"] = "|cffeda55fClick|r to open main window, |cffeda55fShift-click|r to open options."

	if locale == "esMX" then
--		L["Help"] = "Spanish"
	end

	-- inst:DebugTable("LibKarmaAce:LoadLocales", locale, L:GetLocale(Name,true));
	
end


function LibKarmaAce:OnVariablesLoaded( frame, inst )
	local LibStub = LibStub
	
	self._acelib = self._acelib or {
		lib = {
			L	= LibStub and LibStub("AceLocale-3.0", true),
			LZ	= LibStub and LibStub("LibBabble-Zone-3.0", true),
			LB	= LibStub and LibStub("LibBabble-Boss-3.0", true),
			LC	= LibStub and LibStub("LibBabble-Class-3.0", true),
			LI	= LibStub and LibStub("LibBabble-Inventory-3.0", true),
			LT	= LibStub and LibStub("LibBabble-CreatureType-3.0", true),
			fu	= LibStub and LibStub("LibFuBarPlugin-3.0", true);
			aao	= LibStub and LibStub("AceAddon-3.0", true);
			db	= LibStub and LibStub("AceDB-3.0", true)
		},
		locale = {
			mt = {	__newindex = function( t, k, v ) if t[1] then t[1][k] = v end; end,
					__index = function( t, k ) if not k then return end; if rawget(t,k) then return rawget(t,k) end;
						local _,_,c,s,r,f,v = string.find(k, "^(|c%x%x%x%x%x%x%x%x)(.-)(|r)$");
						if c then k,s = s,k end
						for i, v in pairs(t) do
							if type(v) == "table" then
								v = v[k]; f = f or v;
								if v and (i==1 or v~=k) then 
									return c and (c..v..r) or v
								end;
							end
						end;
						if not f then t[k] = k end;
						return c and s or (f or k);
					end, },
			proxy	= {	__newindex = function( t, k, v ) end, __index = function( t, k ) return rawget(rawget(t,1),k); end,	},
			proxyr	= { __newindex = function( t, k, v ) end, __index = function( t, k ) for i, v in pairs(rawget(t,1)) do if v==k then return i end end end, },
			format  = function(t, s, ...) return s and string.format(t[s], ...); end,
		},
		defaults = {
			profile = { minimap = { show = true, position = 225, }, },
			global = { LCapture = { [inst._meta.locale]={} }, LCaptureR = { [inst._meta.locale]={} }, },	
		}	
	};
	local _LG,_lib = self._acelib.locale,self._acelib.lib;
	if not _LG.base then		
		_LG.base	= { };
		_LG.zone	= _lib.LZ	and inst:SafeCall(_lib.LZ.GetUnstrictLookupTable, _lib.LZ);
		_LG.boss	= _lib.LB	and inst:SafeCall(_lib.LB.GetUnstrictLookupTable, _lib.LB);
		_LG.class	= _lib.LC	and inst:SafeCall(_lib.LC.GetUnstrictLookupTable, _lib.LC);
		_LG.inv		= _lib.LI	and inst:SafeCall(_lib.LI.GetUnstrictLookupTable, _lib.LI);
		_LG.ctype	= _lib.LT	and inst:SafeCall(_lib.LT.GetUnstrictLookupTable, _lib.LT);
		_LG.baseR	= setmetatable({_LG.base}, _LG.proxyr);
		_LG.zoneR	= _lib.LZ	and inst:SafeCall(_lib.LZ.GetReverseLookupTable, _lib.LZ);
		_LG.bossR	= _lib.LB	and inst:SafeCall(_lib.LB.GetReverseLookupTable, _lib.LB);
		_LG.classR	= _lib.LC	and inst:SafeCall(_lib.LC.GetReverseLookupTable, _lib.LC);
		_LG.invR	= _lib.LI	and inst:SafeCall(_lib.LI.GetReverseLookupTable, _lib.LI);
		_LG.ctypeR	= _lib.LT	and inst:SafeCall(_lib.LT.GetReverseLookupTable, _lib.LT);
	end
	
	inst._acelib = {
		name	= inst._instance.name.."Ace",
		nameDB	= inst._instance.name.."AceDB",
	};
	setmetatable( inst._acelib, { __index = self._acelib } );
	local _inst,_L = inst._acelib, inst._acelib.locale;

	_inst.db	= _lib.db	and _lib.db:New(_inst.nameDB, _inst.defaults) or inst:_GetDB(nil, _inst.nameDB, _inst.defaults, true);
	_L.capture	= inst._meta.lcapture and _inst.db.global.LCapture[inst._meta.locale] or { }
	_L.captureR	= inst._meta.lcapture and _inst.db.global.LCaptureR[inst._meta.locale] or { }
	_L.inst		= _lib.L and setmetatable({_lib.L:GetLocale(inst._instance.name, true) or {}}, _LG.proxy);
	_L.instR	= _lib.L and setmetatable({_lib.L:GetLocale(inst._instance.name, true) or {}}, _LG.proxyr);
	_inst.L = setmetatable({_L.capture, _LG.zone, _LG.boss, _LG.class, _LG.inv, _LG.ctype, _LG.base, _L.inst, F=_LG.format,}, _LG.mt);
	_inst.LR = setmetatable({_L.captureR, _LG.zoneR, _LG.bossR, _LG.classR, _LG.invR, _LG.ctypeR, _LG.baseR, _L.instR, F=_LG.format,}, _LG.mt);

	if _lib.L then
		self:LoadLocales( frame, inst, inst._meta.locale, _LG.base );
	end
end

function LibKarmaAce:OnPlayerLogin( frame, inst )
	local _inst = inst._acelib;
	
	_inst.instance	= _inst.lib.aao and _inst.lib.aao:NewAddon(_inst.name, "AceConsole-3.0") or { };
	_inst.menu	= _inst.L and _inst.instance and { handler = _inst.instance, type = "group", args = {
			help	= {	type = "execute", order = 10, name = _inst.L["Help"], desc = _inst.L["Show Help"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("help") end,		},
			main	= {	type = "execute", order = 10, name = _inst.L["Main Window"], desc = _inst.L["Show Main Window"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce() end,			},
			options	= {	type = "execute", order = 10, name = _inst.L["Options"], desc = _inst.L["Show Options"],
						passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("options") end,	}, }, };
						
	if _inst.instance then													-- ace
		_inst.instance._karma				= inst;
		_inst.instance._L					= _inst.L;
		_inst.instance.db					= _inst.db;
		_inst.instance.title				= inst._meta.title;
		_inst.instance.version				= inst._meta.version;
		_inst.instance.ExecChatCommandAce	= LibKarmaAce.ExecChatCommandAce;
		_inst.instance.OnMenuRequest		= _inst.menu;
		_inst.instance.OnInitialize			= LibKarmaAce.OnInitialize;
		_inst.instance.OnUpdateFuBarTooltip	= LibKarmaAce.OnUpdateFuBarTooltip;
		_inst.instance.OnFuBarClick			= LibKarmaAce.OnFuBarClick
	end
	if _inst.lib.fu and _inst.lib.aao then									-- fubar via ace
		_inst.lib.aao:EmbedLibrary(_inst.instance, "LibFuBarPlugin-3.0", true); 
		_inst.instance:SetFuBarOption("hasIcon", true)
		_inst.instance:SetFuBarOption("iconPath", inst._meta.icon);
		_inst.instance:SetFuBarOption("hasNoColor", true)
		_inst.instance:SetFuBarOption("hideMenuTitle", true);
		_inst.instance:SetFuBarOption("independentProfile", true)
		_inst.instance:SetFuBarOption("clickableTooltip", true)
		_inst.instance:SetFuBarOption("cannotDetachTooltip", true)
		_inst.instance:SetFuBarOption("hideWithoutStandby", true)
		_inst.instance:SetFuBarOption("defaultPosition", "CENTER")
		_inst.instance:SetFuBarOption("configType", "Dewdrop-2.0")
	else																	-- no fubar, make our own minimap icon 
		_inst.minimap = self:GenerateMinimapButton( frame, inst );
		_inst.minimap:Reposition();
	end

	if CT_RegisterMod then													-- ct mod and related
		CT_RegisterMod(inst._meta.title, "Display window", 5, self._meta.icon,
			self._meta.desc, "switch", _inst.instance, function(self) self:ExecChatCommandAce() end );
	end
	
end


function LibKarmaAce:OnUpdateFuBarTooltip()
	GameTooltip:AddLine(self._L[self.title]);
	GameTooltip:AddLine(self._L["ADDON_TOOLTIP"], 0.2, 1, 0.2, 1);
end


function LibKarmaAce:OnFuBarClick(button)
	self:ExecChatCommandAce( IsShiftKeyDown() and "options" )
end


function LibKarmaAce:ExecChatCommandAce( command )
	local cmd = (command and " "..command) or "";
	self._karma:ExecuteChatCommand( "/"..self._karma._instance.name..cmd );
end


function LibKarmaAce:OnInitialize( )
	local _inst = self._karma._acelib;
	if _inst.menu and _inst.lib.fu then
		self._karma:ArgsToTable(_inst.menu.args, _inst.lib.fu:GetEmbedRockConfigOptions(_inst.instance));
		for i, v in pairs (_inst.menu.args) do
			if v.type == "boolean" then v.type = "toggle" end
			if v.type == "choice" then v.type = "text" end
			if v.choices then v.validate = v.choices end
			if i == "hide" then v.name = "Hide" end
		end
	end
end


function LibKarmaAce:GenerateMinimapButton( frame, inst )
	local _inst = inst._acelib;
	
	self._minimap = self._minimap or {
		OnMouseDown	= function(self) self.icon:SetTexCoord(0, 1, 0, 1) end,
		OnMouseUp	= function(self) self.icon:SetTexCoord(0.075, 0.925, 0.075, 0.925) end,
		OnDragStart	= function(self) self._ismoving = true end,
		OnDragStop	= function(self) self.icon:SetTexCoord(0.075, 0.925, 0.075, 0.925); self._ismoving = false end,
		OnUpdate	= function(self) if self._ismoving then
				local cx, cy = GetCursorPosition()
				local x, y = Minimap:GetCenter()
				local es = Minimap:GetEffectiveScale()
				self:Reposition( math.deg(math.atan2(y*es-cy, x*es-cx))+180 )
			 end end,
		OnClick		= function(self, button) local h=self._handler return h.OnFuBarClick and h:OnFuBarClick(button) end,
		OnEnter		= function(self, button) local g,h=GameTooltip,self._handler; 
			g:SetOwner(self,"ANCHOR_RIGHT"); g:ClearLines(); if h.OnUpdateFuBarTooltip then h:OnUpdateFuBarTooltip() end g:Show() end,
		OnLeave		= function(self, button) GameTooltip:Hide() end,
		Reposition	= function(self, a)
				local o = self._options
				if not o.show then self:Hide(); return end
				a = a or o.position; o.position = a;
				self:Show();
				self:ClearAllPoints();
				self:SetPoint("CENTER", Minimap, "CENTER", (Minimap:GetWidth()/2+10)*cos(a), (Minimap:GetHeight()/2+10)*sin(a))
			end,
	};

	local m = CreateFrame("Button", "", Minimap);
	m._ismoving = false;
	m._handler = _inst.instance;
	m._options = _inst.db.profile.minimap;
	m:SetToplevel(true); m:SetMovable(true); m:SetFrameStrata("LOW");
	m:SetWidth(20);	m:SetHeight(20);
	m:SetPoint("RIGHT", Minimap, "LEFT", 0,0);
	m.icon = m:CreateTexture("", "BACKGROUND")
	m.icon:SetTexture(inst._meta.icon)
	m.icon:SetTexCoord(0.075, 0.925, 0.075, 0.925)
	m.icon:SetWidth(20); m.icon:SetHeight(20);
	m.icon:SetPoint("TOPLEFT", m, "TOPLEFT", 0, 0)
	m.mask = m:CreateTexture("", "OVERLAY")
	m.mask:SetTexture("Interface\\Minimap\\Minimap-TrackingBorder")
	m.mask:SetTexCoord(0.0, 0.6, 0.0, 0.6)
	m.mask:SetWidth(36); m.mask:SetHeight(36);
	m.mask:SetPoint("TOPLEFT", m, "TOPLEFT", -8, 8)
	m:RegisterForClicks("LeftButtonUp","RightButtonUp")
	m:RegisterForDrag("LeftButton")
	m:SetScript("OnMouseUp", self._minimap.OnMouseUp )
	m:SetScript("OnDragStart", self._minimap.OnDragStart )
	m:SetScript("OnDragStop", self._minimap.OnDragStop )
	m:SetScript("OnUpdate", self._minimap.OnUpdate );
	m:SetScript("OnClick", self._minimap.OnClick )
	m:SetScript("OnEnter", self._minimap.OnEnter )
	m:SetScript("OnLeave", self._minimap.OnLeave )
	m.Reposition = self._minimap.Reposition;

	return m;
end
